#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS
#define USE_TI89

#include <tigcclib.h>

const unsigned long relative [8] = {1, 7, 11, 13, 17, 19, 23, 29};

unsigned char IsItPrime(unsigned long Nbr)
// Test for primality using wheel factorization
{
  
  if(!(Nbr % 2) || !(Nbr % 3) || !(Nbr % 5))
  	return FALSE;
  
  long i, j;
  for (i = 7; i*i <= Nbr; i++, i++)
  {
  	for (j = 0; j < 8; j++)
  	{
  		if((i - relative[j]) % 30 == 0)
  		{
  			if(Nbr % i == 0)
  				return FALSE;
  		}
  	}
  }
  return TRUE;
}
void _main(void)
{
  ESI ArgPtr;
  unsigned char NumArgs;

  InitArgPtr(ArgPtr);

  NumArgs = ArgCount();

	// Verify that usage of the program is correct
  if (NumArgs > 1 || GetArgType(ArgPtr) != POSINT_TAG)
  {
    ST_helpMsg("Syntax Error! Uses the form pi(INT)");
    push_END_TAG();
    push_quantum_pair(0x01,0xEC);
    return;
  }

  else
  {
    unsigned long Num1 = (unsigned long) GetIntArg(ArgPtr);

    push_END_TAG();
    unsigned long i;
    unsigned long primes = 3; // for 2, 3, and 5
    switch(Num1)
    {
    	case 2:
    		push_longint(1);
    		return;
    	case 3:
    		push_longint(2);
    		return;
    	case 5:
    		push_longint(3);
    		return;
    	default:
				for(i = 3; i <= Num1; i++, i++)
				{
    			if(IsItPrime(i))
    			primes++;
    		}
    		break;
    }

    push_longint(primes);
    return;
   }
}

